function love.load()
  X = 0
  Y = 0
  TILEW = 60
  TILEH = 30

  Terrain = {}
  for I = 1, 1000 do
    Terrain[I] = {}
    for J = 1, 1000 do
      Terrain[I][J] = love.math.random(58)
    end
  end

  WIDTH, HEIGHT, FLAGS = love.window.getMode()

  quad = {}
  atlas = love.graphics.newImage("atlas.png")
  for i = 1, 58 do
    quad[i] = love.graphics.newQuad(0, (i - 1) * TILEH, atlas:getWidth(), TILEH, atlas:getWidth(), atlas:getHeight())
  end
  map = love.graphics.newSpriteBatch(atlas, (math.ceil(WIDTH / TILEW) + 1) * (math.ceil(HEIGHT * 2 / TILEH) + 1))
  move()
end

function love.update()
  WIDTH, HEIGHT, FLAGS = love.window.getMode()
  if love.keyboard.isDown("right") then
    X = X + 1
  end
  if love.keyboard.isDown("left") then
    X = X - 1
  end
  if love.keyboard.isDown("up") then
    Y = Y - 1
  end
  if love.keyboard.isDown("down") then
    Y = Y + 1
  end
  if love.keyboard.isDown("right") or love.keyboard.isDown("left") or love.keyboard.isDown("up") or love.keyboard.isDown("down") then
    move()
  end
end

function love.draw()
  love.graphics.draw(map)
  love.graphics.print(love.timer.getFPS())
end

function love.keypressed(key)
  if key == "1" then
    love.window.setFullscreen(not FLAGS.fullscreen)
  end
end

function love.resize()
  WIDTH, HEIGHT, FLAGS = love.window.getMode()
  map = love.graphics.newSpriteBatch(atlas, (math.ceil(WIDTH / TILEW) + 1) * (math.ceil(HEIGHT * 2 / TILEH) + 1))
  move()
end

function move()
  map:clear()
  for i = 1, math.ceil(WIDTH / TILEW) + 1 do
    for j = 1, math.ceil(HEIGHT * 2 / TILEH) + 1 do
      I = math.floor((j + 2 * Y) / 2) + (i + X)
      J = 1 + math.ceil((j + 2 * Y) / 2) - (i + X)
      if I >= 1 and J >= 1 and I <= 1000 and J <= 1000 then
        map:add(quad[Terrain[I][J]], ((j - 1) % 2) * TILEW / 2 + (i - 1) * TILEW - atlas:getWidth() / 2, j * TILEH / 2 - TILEH)
    end
  end
end
map:flush()
end